// Datei: ClientSideTemperaturProxy.java
public class ClientSideTemperaturProxy
        implements ITemperaturDienst, ClientProxy {

    private Broker broker;
    private Float response;

    public ClientSideTemperaturProxy(Broker broker) {
        this.broker = broker;
        System.out.println("ClientSideTemperaturProxy: instanziiert");
    }

    public Float erfrageTemperatur(Tag tag) {
        byte[] anfrage = verpacken("erfrageTemperatur", tag);
        broker.anfrageWeiterleiten(anfrage, this);
        return response;
    }

    public void bearbeiteAntwort(byte[] antwort) {
        response = auspacken(antwort);
    }

    private byte[] verpacken(String methode, Tag tag) {
        String anfrage = "ClientTemperaturProxyURL;"
                + methode + ";" + tag.toString();
        return anfrage.getBytes();
    }

    private Float auspacken(byte[] nachricht) {
        String[] strings = (new String(nachricht)).split(";");
        return Float.valueOf(strings[1]);
    }
}