// Datei: ServerImpl.java
package autovermietung.server;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jws.WebService;

@WebService(
   serviceName="AutovermietungService",
   targetNamespace="autovermietung.server",
   portName="FahrzeugMieten",
   endpointInterface="autovermietung.server.IAutovermietung")
public class ServerImpl implements IAutovermietung{

   // Alle verfuegbare Fahrzeugklassen fuer einen Standort auflisten
   public String[] fahrzeugeAuflisten(String standort) {

      String fahrzeuge[] = new String[] {"Oberklasse",
            "Mittelklasse", "Kleinwagen"};

      // Immer drei Fahrzeugklassen verfuegbar
      return fahrzeuge;
   }

   // Fahrzeug an einem Standort reservieren
   public String fahrzeugReservieren(String standort, 
        String fahrzeugklasse) {
      // Freies Fahrzeug ermitteln
      String beispielFahrzeug = "FZ_ID_4711";

      // Fahrzeug als belegt markieren
      System.out.println("Das Fahrzeug mit der Kennung "
          + beispielFahrzeug + " wurde als belegt markiert.");

      // Fahrzeugkennung zurueckgeben
      return beispielFahrzeug;
   }

   // Fahrzeug abholen
   public boolean fahrzeugAbholen(String fahrzeugID) {
      System.out.println("Fahrzeug mit der Kennung "
           + fahrzeugID + " wurde abgeholt.");
       try {
           // Beispiel: Befehl an ein Altsystem uebergeben
           Runtime.getRuntime().exec("legacySystem.exe ...");
       } catch (IOException ex) {
           Logger.getLogger(ServerImpl.class.getName()).log(Level.SEVERE, null, ex);
       }
      return true;
   }

   // Fahrzeug zurueckgeben, freigeben und bezahlen
   public boolean fahrzeugZurueckgeben(String fahrzeugID, 
           String kreditkartenNr) {
      System.out.println("Fahrzeug mit der Kennung " + fahrzeugID 
              + " wurde zurueckgebracht und als frei markiert.");

      if (bezahlen(fahrzeugID, kreditkartenNr)){
         return true;
      } else {
         return false;
      }
   }

   // Fahrzeug bezahlen
   private boolean bezahlen(String fahrzeugID, 
           String kreditkartenNr) {
     // Preis bestimmen und Bezahlung durchfuehren
     System.out.println("Bezahlung fuer das Fahrzeug mit der Kennung "
        + fahrzeugID + " war erfolgreich.");
     return true;
   }
}
