// Datei: Servicenutzer.java
package autovermietung.servicenutzer;

import java.util.List;
import javax.xml.ws.WebServiceRef;
import server.autovermietung.AutovermietungService;
import server.autovermietung.IAutovermietung;

public class Servicenutzer {

    @WebServiceRef(wsdlLocation =
            "http://localhost:8080/AutovermietungServer?wsdl")
    static IAutovermietung service;
    // Hauptprogramm Servicenutzer

    public static void main(String[] args) {
        System.out.println("Servicenutzer gestartet.");
        try {
             // Zugangspunkt zum Server holen
                    service = new AutovermietungService().getFahrzeugMieten();

            // Servicenutzer erzeugen und ein Fahrzeug mieten
            Servicenutzer client = new Servicenutzer();
            client.fahrzeugMieten();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Servicenutzer beendet.");
    }

    //Servicenutzer mietet ein Fahrzeug
    public void fahrzeugMieten() {
        String reservierungsNr;
String standort = "Stuttgart";
      String kreditkartenNr = "abc123456";

      try {
         // Alle verfuegbaren Fahrzeuge auflisten
    List<String> fahrzeuge = 
	  service.fahrzeugeAuflisten(standort);

         System.out.println("Freie Fahrzeuge in " + standort + ":");
         for (int i = 0; i < fahrzeuge.size(); i++) {
            System.out.println("-> " + fahrzeuge.get(i));
         }

         // Ein Fahrzeug reservieren
         System.out.println("Reserviere einen Kleinwagen...");
         reservierungsNr = service.fahrzeugReservieren(
            standort, "Kleinwagen");
         System.out.println("Reserviertes Fahrzeug hat "
            + "die Reservierungsnr. " + reservierungsNr + ".");

         // Fahrzeug abholen
         service.fahrzeugAbholen(reservierungsNr);
         System.out.println("Fahrzeug abgeholt.");

         // Fahrzeug nutzen...

         // Spaeter Fahrzeug zurueckgeben
         service.fahrzeugZurueckgeben(reservierungsNr,
                  kreditkartenNr);
         System.out.println("Fahrzeug zurueckgegeben.");
      } catch (Exception e) {
         e.printStackTrace();
      }
   }
}
