package autovermietung.serviceanbieter;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.GenericEntity;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.xml.bind.annotation.XmlRootElement;

// Datei: AutovermietungImpl.java
@Path( "Autovermietung" )
@XmlRootElement
public class AutovermietungImpl {
  // Alle verfuegbare Fahrzeugklassen fr einen Standort auflisten
  @GET
  @Path("Fahrzeuge/{Standort}")
  @Produces(MediaType.TEXT_PLAIN)
  public String fahrzeugeAuflisten(
      @PathParam("Standort") String Standort) {

     List<String> list = new ArrayList<String>();
     list.add("Oberklasse");
     list.add("Mittelklasse");
     list.add("Kleinwagen");

     // Immer drei Fahrzeugklassen verfuegbar
     return list.toString();
   }

  // Fahrzeug an einem Standort reservieren
  @GET
  @Path("Reservieren/{Standort}/{Fahrzeugklasse}")
  @Produces(MediaType.TEXT_PLAIN)
  public String fahrzeugReservieren(
      @PathParam("Standort") String standort,
      @PathParam("Fahrzeugklasse") String fahrzeugklasse) {

    // Freies Fahrzeug ermitteln
    String beispielFahrzeug = "FZ_ID_4711";

    // Fahrzeug als belegt markieren
    System.out.println("Das Fahrzeug mit der Kennung "
    + beispielFahrzeug + " wurde als belegt markiert.");

    // Fahrzeugkennung zurueckgeben
    return beispielFahrzeug;
  }

  // Fahrzeug abholen
  @GET
  @Path("Abholen/{FahrzeugID}")
  @Produces(MediaType.TEXT_PLAIN)
  public String fahrzeugAbholen(
      @PathParam("FahrzeugID") String fahrzeugID) {
    System.out.println("Fahrzeug mit der Kennung "
        + fahrzeugID + " wurde abgeholt.");
    return "Abholung erfolgreich.";
  }


  // Fahrzeug zurueckgeben, freigeben und bezahlen
  @GET
  @Path("Zurueckgeben/{FahrzeugID}/{KreditkartenNr}")
  @Produces(MediaType.TEXT_PLAIN)
  public String fahrzeugZurueckgeben(
    @PathParam("FahrzeugID") String fahrzeugID,
    @PathParam("KreditkartenNr") String kreditkartenNr) {
      System.out.println("Fahrzeug mit der Kennung " + fahrzeugID
                + " wurde zurueckgebracht und als frei markiert.");

      if (bezahlen(fahrzeugID, kreditkartenNr)){
        return "Bezahlung erfolgreich.";
      } else {
        return "Bezahlung fehlgeschlagen.";
      }
    }

    // Fahrzeug bezahlen
    private boolean bezahlen(String fahrzeugID,String kreditkartenNr){
      // Preis bestimmen und Bezahlung durchfuehren
      System.out.println("Bezahlung fuer das Fahrzeug mit der Kennung "
          + fahrzeugID + " war erfolgreich.");
      return true;
    }
}